#include "DigitalRain.h"
#include "sgfhelper.h"
#include "resource.h"

//ʼַ
static void initRandString(String* s, int col, int y)
{
	if (s)
	{
		s->vy = rand() % (MAX_SPEED_Y - MIN_SPEED_Y) + MIN_SPEED_Y;
		s->y = y;
		s->col = col;

		s->start = 0;
		s->count = rand() % (MAX_STRING_LENGTH - MIN_STRING_LENGTH) + MIN_STRING_LENGTH;
		for (int j = 0; j < s->count; j++)
		{
			s->list[j] = (rand() % ('~' - '!') + '!');
		}
	}
}

//ʼ
DigitalRain* initDigitalRain(int width, int height, int fontSize)
{
	//
	SDL_RWops* rwOps = getResourceData(NULL, MAKEINTRESOURCE(IDR_DEFAULT_FONT), RT_FONT);
	if (rwOps == NULL) {
		return NULL;
	}

	TTF_Font* font = TTF_OpenFontRW(rwOps, 1, fontSize);
	if (font == NULL) {
		return NULL;
	}


	//ṹ
	DigitalRain* dr = malloc(sizeof(DigitalRain));
	if (dr == NULL) {
		TTF_CloseFont(font);
		return NULL;
	}

	//ַ
	char* chW = "W";
	TTF_SizeText(font, chW, &(dr->chW), &(dr->chH));


	//ʼ
	dr->pFont = font;
	dr->winW = width;
	dr->winH = height;
	dr->count = width / dr->chW;
	dr->pCols = malloc(sizeof(String) * dr->count);
	if (dr->pCols)
	{
		for (int i = 0; i < dr->count; i++)
		{
			initRandString(&(dr->pCols[i]), i, -dr->winH);
		}
	}

	return dr;
}


//ʼ
void uninitDigitalRain(DigitalRain* dr)
{
	if (dr == NULL) {
		return;
	}

	if (dr->pCols) {
		free(dr->pCols);
		dr->pCols = NULL;
	}

	if (dr->pFont) {
		TTF_CloseFont(dr->pFont);
		dr->pFont = NULL;
	}

	free(dr);
}


//
void Update(DigitalRain* dr)
{
	if (dr == NULL) {
		return;
	}

	//ö
	for (int i = 0; i < dr->count; i++)
	{
		//ַλ
		dr->pCols[i].y += dr->pCols[i].vy;

		//ɾַľַַ
		int idx = ((dr->pCols[i].start - 1) + MAX_STRING_LENGTH) % MAX_STRING_LENGTH;
		dr->pCols[i].list[idx] = (rand() % ('~' - '!') + '!');
		dr->pCols[i].start = idx;

		
		//ַѾԽ
		if (dr->pCols[i].y - (dr->pCols[i].count * dr->chH) > dr->winH) {
			initRandString(&(dr->pCols[i]), i, -dr->winH);
		}
	}
}


//
void Draw(DigitalRain* dr, SDL_Renderer* renderer)
{
	if (dr == NULL || renderer == NULL) {
		return;
	}

	
	//ö
	for (int i = 0; i < dr->count; i++)
	{
		String* s = &(dr->pCols[i]);

		//֮
		if (s->y < -(s->count * dr->chH)) {
			continue;
		}

		//öַַ
		for (int j = 0; j < s->count; j++)
		{
			SDL_Color color = { 0, 255, 0, 255 };
			if (j == s->count - 1) {
				color.r = 255;
				color.g = 255;
				color.b = 255;
			} else {
				color.r = 0;
				color.g = 255 / s->count * j;
				color.b = 0;
			}

			SDL_Rect dst = { s->col * dr->chW, s->y + dr->chH * j, dr->chW, dr->chH };
			
			//ʾĸ
			char ctmp[2] = { 0 };
			ctmp[0] = s->list[(s->start + j) % MAX_STRING_LENGTH];

			SDL_Surface* surf = TTF_RenderText_Blended(dr->pFont, ctmp, color);
			if (surf) {
				SDL_Texture* texture = SDL_CreateTextureFromSurface(renderer, surf);
				if (texture) {
					SDL_RenderCopy(renderer, texture, NULL, &dst);
					SDL_DestroyTexture(texture);
				}
				SDL_FreeSurface(surf);
			}
		}
	}
}
